----------------------------------------------------
--  Library Name :  updn4
--  Unit    Name :  recnt
--  Unit    Type :  Block Diagram
----------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
entity recnt is
  port (a,b,clk,rst :  in std_logic;
              carry : out std_logic;
                  q : out std_logic_vector(3 downto 0 ) );
end recnt;

architecture recnt of recnt is
  signal enb,ud : std_logic;
  component syncup
      port (a,clk :  in std_logic;
              enb : out std_logic );
  end component;
  component udcnt4
      port (rst,ud,enb,clk :  in std_logic;
                     carry : out std_logic;
                         q : out std_logic_vector(3 downto 0 ) );
  end component;
  component rot
      port (a,b,clk :  in std_logic;
                 ud : out std_logic );
  end component;
begin
  inst_syncup: syncup
    port map (a=>a,enb=>enb,clk=>clk);
  inst_udcnt4: udcnt4
    port map (rst=>rst,ud=>ud,enb=>enb,clk=>clk,carry=>carry,q=>q(3 downto 0));
  inst_rot: rot
    port map (a=>a,b=>b,clk=>clk,ud=>ud);
end recnt;
